VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFrameAsForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'--------------------------------------------------------
'        clsFrameAsForm  (c) peter.k.sauer@web.de 05.2003
'--------------------------------------------------------
'        ein Frame wie eine Form darstellen
'
'        Optionen: Moveable, Exitbutton, Area on Form
'        Events:   ExitButtonClick, isMoved, LostFocus
'--------------------------------------------------------

Option Explicit

'------------- zur Simulation einer Titlebar eines Forms
Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Declare Function DrawCaption Lib "User32" (ByVal hwnd As Long, _
                         ByVal hdc As Long, pcRect As RECT, _
                         ByVal un As Long) As Long

Private Declare Function SetRect Lib "User32" (lpRect As RECT, _
                         ByVal X1 As Long, ByVal Y1 As Long, _
                         ByVal X2 As Long, ByVal Y2 As Long) As Long

Private Const tbarWidth = 20
Private Const tbarColor = &H29
'---------------------------------------------------------

Private WithEvents Parentform As Form        'Parentform des Frames
Attribute Parentform.VB_VarHelpID = -1
Private WithEvents myFrame As Frame          'Frame selbst
Attribute myFrame.VB_VarHelpID = -1
Private ShapeA As Shape                      'Border Frame Left & Top
Private ShapeB As Shape                      'Border Frame Right & Bottom
Private WithEvents PicTitleBar As PictureBox 'die Titlebar
Attribute PicTitleBar.VB_VarHelpID = -1
Private WithEvents LabelText As Label        'Titlebartext
Attribute LabelText.VB_VarHelpID = -1
Private WithEvents CmdExit As CommandButton  'Exitbutton
Attribute CmdExit.VB_VarHelpID = -1
Private WithEvents mTimer As Timer           'zur berprfung des Focus
Attribute mTimer.VB_VarHelpID = -1

Public Event FrameExit()                     'Event Click Exitbutton
Public Event FrameMoved()                    'Event Frame was moved
Public Event LostFocus()                     'Event Frame(Controls) LostFocus

Private MeFormX As Single                    'Variable moving Frame
Private MeFormY As Single
Private MeMouseDown As Boolean


Private mvarMoveable As Boolean              'Frame is moveable
Private mvarExitButton As Boolean            'Exitbutton or not

Private mvarOnFormTopMax As Single           'Area moving Frame
Private mvarOnFormLeftMax As Single
Private mvarOnFormRightMax As Single
Private mvarOnFormBottomMax As Single

Private mvarVisible As Boolean               'Frame visible schalten

Public Property Let Visible(ByVal vData As Boolean)
      mvarVisible = vData
      myFrame.Visible = vData
      If myFrame.Visible Then
         PicTitleBar.SetFocus
      End If
End Property

Public Property Get Visible() As Boolean
    Visible = mvarVisible
End Property

Public Property Let Caption(ByVal vData As String)
      LabelText.Caption = vData
End Property

Public Property Get Caption() As String
      Caption = LabelText.Caption
End Property

Public Property Let OnFormBottomMax(ByVal vData As Single)
    mvarOnFormBottomMax = vData
End Property

Public Property Get OnFormBottomMax() As Single
    OnFormBottomMax = mvarOnFormBottomMax
End Property

Public Property Let OnFormRightMax(ByVal vData As Single)
    mvarOnFormRightMax = vData
End Property

Public Property Get OnFormRightMax() As Single
    OnFormRightMax = mvarOnFormRightMax
End Property

Public Property Let OnFormLeftMax(ByVal vData As Single)
    mvarOnFormLeftMax = vData
End Property

Public Property Get OnFormLeftMax() As Single
    OnFormLeftMax = mvarOnFormLeftMax
End Property

Public Property Let OnFormTopMax(ByVal vData As Single)
    mvarOnFormTopMax = vData
End Property

Public Property Get OnFormTopMax() As Single
    OnFormTopMax = mvarOnFormTopMax
End Property

Public Property Let ExitButton(ByVal vData As Boolean)
'Exitbutton zugelassen oder nicht

      mvarExitButton = vData
      If mvarExitButton Then
         CmdExit.Visible = True
      Else
         CmdExit.Visible = False
      End If
End Property

Public Property Get ExitButton() As Boolean
      ExitButton = mvarExitButton
End Property

Public Property Let Moveable(ByVal vData As Boolean)
      mvarMoveable = vData
End Property

Public Property Get Moveable() As Boolean
      Moveable = mvarMoveable
End Property

Public Sub Init(mFrame As Frame, Optional IsVisible As Boolean = True)
'Initialisieren Frame und sonstige Controls

   Static Initdone As Boolean
   Dim i As Long
   Dim s As String

      If Initdone Then
         'nicht 2 x aufrufen
         Exit Sub
      End If
      Initdone = True
      
      'zuweisen Frame
      Set myFrame = mFrame
      'zuweisen der Parentform (aufrufende Form)
      Set Parentform = mFrame.Parent
      
      'Grenzen fr das Frame auf der Form
      mvarOnFormTopMax = 0
      mvarOnFormLeftMax = 0
      mvarOnFormRightMax = 0
      mvarOnFormBottomMax = 0

      'Controls aufnehmen in Parentform Collection
      Set LabelText = LoadControl("VB.Label", "FaF_LabelText")
      Set PicTitleBar = LoadControl("VB.Picturebox", "FAF_PicTitleBar")
      Set ShapeA = LoadControl("VB.Shape", "FaF_ShapeA")
      Set ShapeB = LoadControl("VB.Shape", "FaF_ShapeB")
      Set CmdExit = LoadControl("VB.CommandButton", "FaF_CmdExit")
      Set mTimer = LoadControl("VB.Timer", "FaF_mTimer")
      
      'Controls einrichten
      SetControls
      
      'anzeigen
      Visible = IsVisible
End Sub

Private Function LoadControl(LibraryName As String, _
                             objCtlName As String) As Control
'ein Control auf die Parentform beamen

   Dim i As Long
   Dim s As String
   Dim objCtl As Control
   
      i = 1
      Do
         On Error Resume Next
         'durch Anhngen einer Laufnummer eindeutige Bezeichner bilden
         s = objCtlName & i
         'Control in Parentform Collection aufnehmen
         Set objCtl = Parentform.Controls.Add(LibraryName, s, Parentform)
         If Err.Number = 0 Then
            'kein Fehler
            Exit Do
         ElseIf Err.Number = 727 Then
            'Control mit Bezeichner schon vorhanden, Laufnummer + 1
            i = i + 1
            Err.Clear
         Else
            'sonstiger Fehler
            FehlerAnzeige Err.Number, Err.Description, "clsFrameAsForm.LoadControl"
            Exit Do
         End If
      Loop
      
      'Control zuweisen
      Set LoadControl = objCtl
      Set objCtl = Nothing
End Function

Private Sub SetControls()
'Controls endgltig einrichten

   Dim R As RECT

      'Frame ohne Border setzen
      myFrame.BorderStyle = 0

      'Border Right & Bottom
      With ShapeA
         Set .Container = myFrame
         .BorderWidth = 2
         .BorderColor = vb3DDKShadow
         .Top = -60
         .Left = -60
         .Width = myFrame.Width + 60
         .Height = myFrame.Height + 60
         .Visible = True
      End With
      
      'Border Left & Top
      With ShapeB
         Set .Container = myFrame
         .BorderWidth = 3
         .BorderColor = vb3DHighlight
         .Top = 0
         .Left = 0
         .Width = myFrame.Width + 60
         .Height = myFrame.Height + 60
         .Visible = True
      End With

      'Titlebar
      With PicTitleBar
         Set .Container = myFrame
         .TabStop = False
         .Left = 60
         .Top = 60
         .Width = myFrame.Width - 120
         .BorderStyle = 0
         .ScaleMode = vbPixels
         .Height = 18 * Screen.TwipsPerPixelY
         .AutoRedraw = True
         .Cls
         .Visible = True
         'Fill Rect
         SetRect R, 0, 0, PicTitleBar.ScaleWidth, tbarWidth
         'Draw Titlebar
         DrawCaption PicTitleBar.hwnd, PicTitleBar.hdc, R, tbarColor
         .AutoRedraw = False
      End With
      
      'Titlebar Caption
      With LabelText
         Set .Container = PicTitleBar
         .Caption = myFrame.Caption
         .BorderStyle = 0
         .BackStyle = 1
         .FontBold = True
         .BackStyle = 0
         .ForeColor = vbTitleBarText
         .AutoSize = True
         .Top = (PicTitleBar.ScaleHeight - .Height) / 2
         .Left = 5
         .Visible = True
      End With
      
      'Exitbutton
      With CmdExit
         Set .Container = PicTitleBar
         .Caption = "r"
         .FontName = "Marlett"
         .FontSize = 8
         .FontBold = False
         .FontItalic = False
         .Width = 17
         .Height = 14
         .Top = 2
         .Left = PicTitleBar.ScaleWidth - .Width - 2
         .TabStop = False
         .Visible = True
      End With
      
      'der Timer
      mTimer.Interval = 500
      mTimer.Enabled = True
End Sub

Private Function IsActiveControlOnFrame() As Boolean
'ist der Focus bei einem Steuerelement des Frames

      If Parentform.ActiveControl.Container = myFrame Then
         IsActiveControlOnFrame = True
      End If
End Function

Private Sub Class_Initialize()
'Grundeinstellungen (Default)
      
      mvarExitButton = True
      mvarMoveable = True
End Sub

Private Sub Class_Terminate()
'Objecte aus Parentform entfernen und terminieren
      
      Parentform.Controls.Remove LabelText
      Parentform.Controls.Remove ShapeA
      Parentform.Controls.Remove ShapeB
      Parentform.Controls.Remove CmdExit
      Parentform.Controls.Remove mTimer
      Parentform.Controls.Remove PicTitleBar
      
      Set mTimer = Nothing
      Set LabelText = Nothing
      Set ShapeA = Nothing
      Set ShapeB = Nothing
      Set CmdExit = Nothing
      Set PicTitleBar = Nothing
      Set Parentform = Nothing
End Sub

Private Sub CmdExit_Click()
'Abbruch
      
      'Frame unvisible
      myFrame.Visible = False
      'Event fr Parentform auslsen
      RaiseEvent FrameExit
End Sub

Private Sub MoveFrame(X As Single, Y As Single)
'Frame verschieben

   Dim X1 As Single
   Dim Y1 As Single

      'beachten des vorgegebenen Areas beim Verschieben
      With myFrame
         X1 = .Left + X - MeFormX
         Y1 = .Top + Y - MeFormY
         If X1 > (Parentform.ScaleWidth - OnFormRightMax - .Width) Then
            X1 = Parentform.ScaleWidth - OnFormRightMax - .Width
         End If
         If X1 < OnFormLeftMax Then
            X1 = OnFormLeftMax
         End If
         If Y1 > (Parentform.ScaleHeight - OnFormBottomMax - .Height) Then
            Y1 = Parentform.ScaleHeight - OnFormBottomMax - .Height
         End If
         If Y1 < OnFormTopMax Then
            Y1 = OnFormTopMax
         End If
         .Left = X1
         .Top = Y1
      End With
End Sub

Private Sub LabelText_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Verweis auf PicTitleBar

      PicTitleBar_MouseDown Button, Shift, X, Y
End Sub

Private Sub LabelText_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Verweis auf PicTitleBar

      PicTitleBar_MouseMove Button, Shift, X, Y
End Sub

Private Sub LabelText_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Verweis auf PicTitleBar

      PicTitleBar_MouseUp Button, Shift, X, Y
End Sub

Private Sub FehlerAnzeige(ErrNumber As Long, ErrDescription As String, _
                         Optional Titel As String = "")

   Dim Msg As String
   
      Msg = "Fehler " & ErrNumber & vbCrLf & vbCrLf & _
            ErrDescription
      MsgBox Msg, vbCritical, Titel
End Sub

Private Sub mTimer_Timer()

      'berprfen, ob das Focus haltende Steuerelement
      'zum Frame gehrt
      If Not myFrame.Visible Then
         Exit Sub
      End If
      
      If Not Parentform.ActiveControl.Container Is myFrame Then
         'nein, Event LostFocus feuern
         RaiseEvent LostFocus
      End If
End Sub

Private Sub myFrame_Click()
'beim Click auf das Frame

      'in den Vordergrund
      myFrame.ZOrder 0
      
      'wenn der Focus nicht bei einem Steuerelement
      'des Frames liegt
      If Not IsActiveControlOnFrame Then
         PicTitleBar.SetFocus
      End If
End Sub

Public Sub Refresh()
'Refreshen

      SetControls
End Sub

Private Sub Parentform_Resize()
'reagieren auf vbMaximize, vbNormal, FormResize

      MeFormX = myFrame.Left
      MeFormY = myFrame.Top
      MoveFrame MeFormX, MeFormY
End Sub

Private Sub PicTitleBar_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Beginn Moven

      'in den Vordergrund
      myFrame.ZOrder 0

      If Not Moveable Then
         Exit Sub
      End If
      
      MeMouseDown = True
      MeFormX = X
      MeFormY = Y
      
      'der Focus liegt hier
      PicTitleBar.SetFocus
End Sub

Private Sub PicTitleBar_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Frame moven

      If MeMouseDown Then
         MoveFrame X, Y
         'Event auslsen
         RaiseEvent FrameMoved
      End If

End Sub

Private Sub PicTitleBar_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

'Ende Frame moven

      MeMouseDown = False
End Sub
